<?php

// ----------------------------------------------------------------------
//   File        : inc_contactlist.php
//   Description : display a list of telephone records
//   Version     : 1.0
//   Created     : 1/9/2015
//   Author      : Tim Lockwood
//
// ----------------------------------------------------------------------




include("inc_security.php");




//define global variables
global $intPage;
global $intPageSize;
global $intRecordsFound;
global $SQLstmt;
global $intStartRecord;
global $intTotalPages;
global $strAdminState;



//accept variables

if (isset($_REQUEST['pn']))
   $intPage = $_REQUEST['pn'];
else
   $intPage = 1;

$intStartRecord = (($intPage*$intPageSize)-($intPageSize));




print("<div id=\"funcbar\"><div id=\"adduser\"><a href=\"" . $_SERVER['PHP_SELF'] . "?pageaction=newcontact$strAdminState\"><img src=\"images/addcontact.gif\" border=\"0\" alt=\"add contact\"></a></div></div>");

ScreenHeading("Telephone contacts");




//main list page logic

print("<div id=\"telephonelistcontainer\">\n");

DisplaySearchForm();
SqlPrep();
RecordCount();
GetPageTotal();

if ($intRecordsFound > 0)
{
   SqlForResults();
   SearchFeedback();

   print("<div id=\"statusbar\">\n");
   ResultsStatus();
   print("</div>\n"); // end statusbar div

   DisplayRecords();
   DisplayPagedNavigation($intTotalPages, $intPage);
   print("<div id=\"bottomspacer\"></div>");
}
else
{
   SearchFeedback();
   NoRecordsFound();
   print("<div id=\"bottomspacer\"></div>");
}

print("</div>\n"); // end telephonelistcontainer div




// ----------------------------------------------------------------------
//   Function    : DisplaySearchForm
//   Description : display a search form including keyword search
//   Usage       : DisplaySearchForm()
//
// ----------------------------------------------------------------------

function DisplaySearchForm() {

   print("<div id=\"searchbar\">\n");
   print("<table>\n");
   print("<form action=\"" . $_SERVER['PHP_SELF'] ."\" method=\"POST\">\n");
   print("<input type=\"hidden\" name=\"pageaction\" value=\"releases\">\n");
   print("  <tr>\n");
   print("    <td class=\"searchfieldshead\">Keyword</td>\n");
   print("    <td class=\"searchfieldshead\">Department</td>\n");
   print("    <td></td>\n");
   print("  </tr>\n");
   print("  <tr>\n");
   print("    <td><input type=\"text\" name=\"key\"></td>\n");
   print("    <td>\n");
   include("includes/departmentdropdownsearch.php");
   print("    </td>\n");
   print("    <td><input type=\"image\" src=\"images/search.gif\" class=\"searchbutton\"></td>\n");
   print("  </tr>\n");
   print("</form>\n");
   print("</table>\n");
   print("</div>\n"); // end searchbar div

}




// ----------------------------------------------------------------------
//   Function    : SqlPrep
//   Description : sets SQL variables to find number of records found
//                 and prepare to run main query
//   Usage       : SqlPrep()
//
// ----------------------------------------------------------------------

function SqlPrep() {

   global $SQLstmt, $SQLselect, $SQLfrom, $SQLwhere;
   global $strKey, $intDepartment;
   global $SETDebug;

   //Build FROM part
   $SQLfrom =  " FROM tdcontact";


   //Build WHERE part
   if ($strKey != "")
   {
      $SQLwhere .= " WHERE (lastname LIKE '%$strKey%' OR firstname LIKE '%$strKey%')"; 
   }


   if ($intDepartment != "")
   {
      if ($SQLwhere != "")
	  {
	     $SQLwhere .= " AND";
	  }
	  else
	  {
	     $SQLwhere .= " WHERE";
	  }
      $SQLwhere .= " departmentID = '$intDepartment'";
   }
   
   
   //SQL to find number of records
   $SQLselect = "SELECT COUNT(*)";
   $SQLstmt = $SQLselect . $SQLfrom . $SQLwhere;

   if ($SETDebug == "ON")
   {
      print("<div class=\"debug\">$SQLstmt</div>");
   }

}




// ----------------------------------------------------------------------
//   Function    : RecordCount
//   Description : returns number of records found during search
//   Usage       : RecordCount($SQLstmt)
//   Parameters  : $SQLstmt - SQL for total query record count
//   Returns     : $intRecordsFound - how many records will be returned
//                 by query
//
// ----------------------------------------------------------------------

function RecordCount() {

   global $SQLstmt;
   global $intRecordsFound;

   $resultSet = dbaction($SQLstmt);
   $row = getrsrow($resultSet);
   $intRecordsFound = $row[0];

}




// ----------------------------------------------------------------------
//   Function    : GetPageTotal
//   Description : return the number of record result pages available
//                 using the total number of records found and the
//                 page size from the settings.php file
//   Usage       : GetPageTotal()
//   Returns     : intTotalPages - how many record result pages there are
//                 given the number of records found and the page size
//                 setting
//
// ----------------------------------------------------------------------

function GetPageTotal() {

   global $intPageSize;
   global $intRecordsFound;
   global $intTotalPages;

   if (fmod($intRecordsFound, $intPageSize) == 0)
   {
      $intTotalPages = $intRecordsFound/$intPageSize;      
   }
   else
   {
      $intTotalPages = ceil($intRecordsFound/$intPageSize);
   }

}




// ----------------------------------------------------------------------
//   Function    : SqlForResults
//   Description : creates the remainder of the sql parts required and 
//                 sets the actual record retrieval SQL query 
//   Usage       : SqlForResults()
//
// ----------------------------------------------------------------------

function SqlForResults() {

   global $SQLstmt, $SQLselect, $SQLfrom, $SQLwhere, $SQLorder;
   global $intPageSize, $intStartRecord;
   global $SETDebug;

   //SQL to retrieve all or a subset of user records
   $SQLselect = "SELECT contactID, firstname, lastname, recordstatus";
   $SQLorder = " ORDER BY lastname ASC";
   $SQLlimit = " LIMIT $intStartRecord, $intPageSize";
   $SQLstmt = $SQLselect . $SQLfrom . $SQLwhere . $SQLorder . $SQLlimit;

   if ($SETDebug == "ON")
   {
      print("<div class=\"debug\">$SQLstmt</div>\n");
   }

}




// ----------------------------------------------------------------------
//   Function    : SearchFeedback
//   Description : displays the search criteria you specified for the
//                 record search
//   Usage       : SearchFeedback()
//
// ----------------------------------------------------------------------

function SearchFeedback() {

global $strKey, $intDepartment;

   print("<div id=\"searchfeedback\">\n");

   if ($strKey != "" || $intDepartment != "")
   {

      print("You searched on&nbsp;&nbsp;");
	  
      if ($strKey != "")
	  {
         print("Keyword: <span class=\"searchfeedbackbold\">" . stripslashes($strKey) . "</span> &nbsp;&nbsp;");   		 
      } 	 
   
      if ($intDepartment != "")
	  {
	     $SQLstmt2 = "SELECT departmentname FROM tddepartment WHERE departmentID = '$intDepartment'";
		 $resultSet2 = dbaction($SQLstmt2);
		 $row2 = getrsrow($resultSet2);
		 print("Department: <span class=\"searchfeedbackbold\">" . $row2["departmentname"] . "</span>");
		 
	  }
   
   }

   print("</div>\n"); // end searchfeedback div

}




// ----------------------------------------------------------------------
//   Function    : ResultsStatus
//   Description : shows status info on the number of records returned in
//                 a result list and which ones are currently shown
//   Usage       : ResultsStatus()
//
// ----------------------------------------------------------------------

function ResultsStatus() {

   global $intPage;
   global $intPageSize;
   global $intStartRecord;
   global $intRecordsFound;

   print("<div id=\"recordsfound\">");
   print("Showing results <span class=\"recordsfoundbold\">" . ($intStartRecord+1) . ""); 
   print("</span> - <span class=\"recordsfoundbold\">");

   if (($intPageSize*$intPage) < $intRecordsFound)
   {
      print($intPageSize*$intPage);
   }
   else
   {
      print($intRecordsFound);
   }            

   print(" </span> of <span class=\"recordsfoundbold\">$intRecordsFound</span>");
   print("</div>\n");

}




// ----------------------------------------------------------------------
//   Function    : DisplayRecords
//   Description : display the query results in a data table
//   Usage       : DisplayRecords()
//
// ----------------------------------------------------------------------

function DisplayRecords() {

   global $strAdminState;
   global $SQLstmt;

   $resultSet = dbaction($SQLstmt);


   //check to see if only 1 record is in this page to avoid state errors with deletions later on
   if (lastrec($resultSet)) 
   {
      $strLastRec = "yes";
   }


   print("<div id=\"releaselist\">\n");

   print("<table class=\"datatable\" border=\"0\" cellpadding=\"3\" cellspacing=\"1\" width=\"600\">\n");
   print("  <tr>\n");
   print("    <td class=\"datatablehead\" align=\"center\">View</td>\n");
   print("    <td class=\"datatablehead\" align=\"center\">Edit</td>\n");
   print("    <td class=\"datatablehead\" align=\"center\">Delete</td>\n");
   print("    <td class=\"datatablehead\">Name</td>\n");
   print("    <td class=\"datatablehead\">Publish</td>\n");
   print("  </tr>\n");


   $intAltRow = 1;

   while ($row = getrsrow($resultSet))
   {
      if ($intAltRow == 1)
         print("<tr class=\"datarowon\">\n");
      else
         print("<tr class=\"datarowoff\">\n");


      print("    <td width=\"38\" align=\"center\"><a href=\"" . $_SERVER['PHP_SELF'] . "?pageaction=viewcontact&id=" . $row["contactID"] . "$strAdminState\"><img src=\"images/viewicon.gif\" border=\"0\"></a></td>\n");
      print("    <td width=\"38\" align=\"center\"><a href=\"" . $_SERVER['PHP_SELF'] . "?pageaction=editcontact&id=" . $row["contactID"] . "$strAdminState\"><img src=\"images/editicon.gif\" border=\"0\"></a></td>\n");
      print("    <td width=\"38\" align=\"center\"><a href=\"" . $_SERVER['PHP_SELF'] . "?pageaction=deletecontact&id=" . $row["contactID"] . "&name=" . urlencode($row["firstname"] . " " . $row["lastname"]) . "$strAdminState");
      if (isset($strLastRec))
         print("&lastrec=true");      
      print("\"><img src=\"images/deleteicon.gif\" border=\"0\"></a></td>\n");
      print("    <td>" . $row["firstname"] . " " . $row["lastname"] . "&nbsp;</td>\n"); 
      print("    <td>");
      if ($row["recordstatus"] == "active")
         print $row["recordstatus"];
      else
         print("<span class=\"inactive\">inactive</span>");
      print("</td>\n");
      print("  </tr>\n");

      if ($intAltRow == 1)
         $intAltRow = 0;
      else
         $intAltRow = 1;

   }

   print("</table>\n");
   print("</div>\n"); // end userlist div

}




// ----------------------------------------------------------------------
//   Function    : NoRecordsFound
//   Description : print no records found message
//   Usage       : NoRecordsFound()
//
// ----------------------------------------------------------------------

function NoRecordsFound() {

   BasicMessage("No records found");

}


?>

