<?php

// ----------------------------------------------------------------------
//   File        : inc_editupdatedepartment.php
//   Description : displays a data populated form to update an existing
//                 department record. Submitting form validates data and 
//                 updates department record.  It is only available to 
//                 Super and Administrator users.
//   Version     : 1.0
//   Created     : 1/9/2015
//   Author      : Tim Lockwood
//
// ----------------------------------------------------------------------




include("inc_security.php");




screenheading("Edit department");




if ($_SESSION['AccessLevel'] == 'Super' || $_SESSION['AccessLevel'] == 'Administrator')
{

   //get subaction
   if (isset($_REQUEST['subaction']))
      $strSubAction = $_REQUEST['subaction'];
   else
      $strSubAction = NULL;
   
   //get record id
      if (isset($_REQUEST['id']))
      $intID = $_REQUEST['id'];
   else
      $intID = NULL;
	  
	  
   if ($strSubAction == "submit") {
   
      //accept data
	  if (isset($_REQUEST['departmentname']))
         $strDepartmentName = substr($_REQUEST['departmentname'],0,100);
      else
         $strDepartmentName = NULL;
		 
		 
	  //prepare data if magic quotes is off
      if (!get_magic_quotes_gpc()) {
		 $strDepartmentName = addslashes($strDepartmentName);
	  }
	  
	  
      //validate form
      $booValid = TRUE;
	  $strValidateError = "";

  
	  //check departmentname field not empty
	  if ($strDepartmentName == "") {
	     $booValid = FALSE;
		 $strValidateError = $strValidateError . "<li>Department Name cannot be empty<br>";
	  }
	  
	  
	  //check not duplicate departmentname
	  if ($strDepartmentName != "") {
	     $sqlStmt = "SELECT * FROM tddepartment WHERE departmentname = '$strDepartmentName'";
	     $rs = dbaction($sqlStmt);
	     if ($row = getrsrow($rs)) {
	        $booValid = FALSE;
            $strValidateError = $strValidateError . "<li>Department Name already exists<br>";		 
	     }
	  }
	  
	  
	  //populate data
	  if ($booValid) {
	     UpdateNewDepartment($intID, $strDepartmentName);
	  }
	  else
	  {
	     DisplayEditDepartmentForm($strSubAction, $strValidateError, $intID, $strDepartmentName);
	  }
	  
   }
   else {
      DisplayEditDepartmentForm($strSubAction, "", $intID, "");
   }

}
else
{
   BasicMessage("You do not have access to this area");
}




function DisplayEditDepartmentForm($strSubAction, $strValidateError, $intID, $strDepartmentName) {

   global $strFormAdminState;
   
   //get data to populateform
   if ($strSubAction == "")
   {
      $SQLstmt = "SELECT departmentname FROM tddepartment WHERE departmentID = '$intID'";
   
      $resultSet = dbaction($SQLstmt);
      $row = getrsrow($resultSet);
   }
   
   print("<table class=\"formtable\" width=\"572\" border=\"0\" cellpadding=\"2\" cellspacing=\"2\">\n");
   print("<form action=\"" . $_SERVER['PHP_SELF'] . "\" method=\"post\">\n");
   print("<input type=\"hidden\" name=\"pageaction\" value=\"updatedepartment\">\n");
   print("<input type=\"hidden\" name=\"id\" value=\"$intID\">\n");   
   print $strFormAdminState;
   print("<input type=\"hidden\" name=\"subaction\" value=\"submit\">\n"); 
   
   //print errors if submit not valid
   if ($strValidateError != "" ) {
      print("  <tr>\n");
      print("    <td colspan=\"2\"><div id=\"formerror\">ERROR: Form not submitted due to invalid fields<br>" . $strValidateError . "</div></td>\n");
      print("  </tr>\n");
   }
   
      print("  <tr>\n");
   print("    <td class=\"formhead\">&nbsp;Department Name</td>\n");
   print("    <td class=\"formtext\"><input type=\"text\" name=\"departmentname\" class=\"formitem\"");
   if ($strSubAction == "")
   {
      print(" value=\"" . $row["departmentname"] . "\"");
   }
   else
   { 
      if ($strValidateError != "" )
         print(" value=\"" . $strDepartmentName . "\"");   
   }
   print("></td>\n");
   print("  </tr>\n");
   print("  <tr>\n");
   print("    <td class=\"formspacer\" colspan=\"2\"></td>\n");
   print("  </tr>\n");     
   print("  <tr>\n");
   print("    <td>&nbsp;</td>\n");
   print("    <td><input type=\"submit\" value=\"update department\"></td>\n");
   print("  </tr>\n");
   print("</table>\n");
   print("</form>\n");
   
}




function UpdateNewDepartment($intID, $strDepartmentName) {

   global $strAdminState;

   @ $dtDatetime = date("h:i A l F dS, Y");

   //generate sql statement
   $SQLstmt = "UPDATE tddepartment SET " .
   "departmentname = '$strDepartmentName', " .
   "recordlastmodifiedby = '" . addslashes($_SESSION['Username']) . "', " .
   "recordlastmodified = '$dtDatetime' " .
   "WHERE departmentID = '$intID'";
   
   // execute statement
   dbaction($SQLstmt); 

   ConfirmMessage("Department record updated", "" . $_SERVER['PHP_SELF'] . "?pageaction=departmentlist$strAdminState");
  	  
}



?>
