<?php

// ----------------------------------------------------------------------
//   File        : inc_newsavedepartment.php
//   Description : displays form to enter a new department record. 
//				   Submitting form validates data and saves department
//                 record.
//	 			   It is only available to Super and Administrator users.
//   Version     : 1.0
//   Created     : 1/12/2014
//   Author      : Tim Lockwood
//
// ----------------------------------------------------------------------




include("inc_security.php");




screenheading("New department");




if ($_SESSION['AccessLevel'] == 'Super' || $_SESSION['AccessLevel'] == 'Administrator')
{

   //get subaction
   if (isset($_REQUEST['subaction']))
      $strSubAction = $_REQUEST['subaction'];
   else
      $strSubAction = NULL;
   
   
   if ($strSubAction == "submit") {
   
      //accept data
	  if (isset($_REQUEST['departmentname']))
         $strDepartmentName = substr($_REQUEST['departmentname'],0,100);
      else
         $stDepartmentName = NULL;
	  
		 
		 
	  //prepare data if magic quotes is off
      if (!get_magic_quotes_gpc()) {
	     $strDepartmentName = addslashes($strDepartmentName);
	  }
	  
	  
      //validate form
      $booValid = TRUE;
	  $strValidateError = "";

	  //check category field not empty
	  if ($strDepartmentName == "") {
	     $booValid = FALSE;
		 $strValidateError = $strValidateError . "<li>Department name cannot be empty<br>";
	  }
	  	  
	  //check not duplicate departmentname
	  if ($strDepartmentName != "") {
	     $sqlStmt = "SELECT * FROM tddepartment WHERE departmentname = '$strDepartmentName'";
	     $rs = dbaction($sqlStmt);
	     if ($row = getrsrow($rs)) {
	        $booValid = FALSE;
            $strValidateError = $strValidateError . "<li>Department Name already exists<br>";		 
	     }
	  }
	  
	  
	  //populate data
	  if ($booValid) {
	     SaveNewDepartment($strDepartmentName);
	  }
	  else
	  {
	     DisplayNewDepartmentForm($strValidateError, $strDepartmentName);
	  }
	  
   }
   else {
      DisplayNewDepartmentForm("", "");
   }

}
else
{
   BasicMessage("You do not have access to this area");
}




function DisplayNewDepartmentForm($strValidateError, $strDepartmentName) {

   global $strFormAdminState;
   
   print("<table class=\"formtable\" width=\"572\" border=\"0\" cellpadding=\"2\" cellspacing=\"2\">\n");
   print("<form action=\"" . $_SERVER['PHP_SELF'] . "\" method=\"post\">\n");
   print("<input type=\"hidden\" name=\"pageaction\" value=\"savedepartment\">\n");
   print $strFormAdminState;
   print("<input type=\"hidden\" name=\"subaction\" value=\"submit\">\n"); 
   
   //print errors if submit not valid
   if ($strValidateError != "" ) {
      print("  <tr>\n");
      print("    <td colspan=\"2\"><div id=\"formerror\">ERROR: Form not submitted due to invalid fields<br>" . $strValidateError . "</div></td>\n");
      print("  </tr>\n");
   }
   
   print("  <tr>\n");
   print("    <td class=\"formhead\">&nbsp;Department Name</td>\n");
   print("    <td class=\"formtext\"><input type=\"text\" name=\"departmentname\" class=\"formitem\"");
   if ($strValidateError != "" )
      print(" value=\"" . $strDepartmentName . "\"");
   print("></td>\n");
   print("  </tr>\n");
   
   print("  <tr>\n");
   print("    <td class=\"formspacer\" colspan=\"2\"></td>\n");
   print("  </tr>\n");     
   print("  <tr>\n");
   print("    <td>&nbsp;</td>\n");
   print("    <td><input type=\"submit\" value=\"save department\"></td>\n");
   print("  </tr>\n");
   print("</table>\n");
   print("</form>\n");
   
}




function SaveNewDepartment($strDepartmentName) {

   global $strAdminState;

   @ $dtDatetime = date("h:i A l F dS, Y");

   //generate sql statement
   $sqlStmt = "INSERT INTO tddepartment VALUES (" .
   "NULL, '$strDepartmentName', '$dtDatetime', '" . addslashes($_SESSION['Username']) . "', '$dtDatetime', '" . addslashes($_SESSION['Username']) . "')";

   // execute statement
   dbaction($sqlStmt); 

   ConfirmMessage("New department record saved", "" . $_SERVER['PHP_SELF'] . "?pageaction=departmentlist$strAdminState");
  	  
}




?>