<?php

// ----------------------------------------------------------------------
//   File        : publicsearch.php
//   Description : search and display list of telephone contacts
//   Version     : 1.0
//   Created     : 1/9/2015
//   Author      : Tim Lockwood
//
// ----------------------------------------------------------------------




include("settings.php");
include("databasewrapper.php");




$strPublicState = GetPublicState(0);
$strNavPublicState = GetPublicState(1);




//accept parameters
if (isset($_REQUEST['stype']))
   $strSearchType = $_REQUEST['stype'];
else
   $strSearchType = NULL;
   
if (isset($_REQUEST['key']))
   $strKey = $_REQUEST['key'];
else
   $strKey = NULL;

if (isset($_REQUEST['department']))
   (int)$intDepartment = $_REQUEST['department'];
else
   $intDepartment = NULL;   

if (isset($_REQUEST['id']))
   (int)$intContactID = $_REQUEST['id'];
else
   $intContactID = NULL;

if (isset($_REQUEST['pn']))
   $intPage = $_REQUEST['pn'];
else
   $intPage = 1;

$intStartRecord = (($intPage*$intPublicPageSize)-($intPublicPageSize));

   
//prepare data if magic quotes is off
if (!get_magic_quotes_gpc()) {
   $strKey = addslashes($strKey);
   $intDepartment = addslashes($intDepartment);
   $intContactID = addslashes($intContactID);   
}	  




print("<div id=\"tdcontainer\">\n");

if ($strSearchType == "view")
{
   SearchBar();
   ViewContact($intContactID);
}
else
{
   SqlPrep(); 
   $intRecordsFound = RecordCount($SQLstmt);
   $intTotalPages = GetPageTotal();
      
   if ($intRecordsFound > 0)
   {
      SqlForResults();
      SearchBar();
      SearchFeedback();
      ResultsStatus();
      TelephoneDirectory();
	  DisplayPagedNavigation($intTotalPages, $intPage);
	  print("<div id=\"bottomspacer\"></div>");
   }
   else
   {
      SearchBar();
      SearchFeedback();
      NoRecordsFound();
	  print("<div id=\"bottomspacer\"></div>");
   } 
   
}
   
print("</div>\n"); // end tdcontainer div




// ----------------------------------------------------------------------
//   Function    : SearchBar
//   Description : Displays form with search options
//   Usage       : SearchBar()
//
// ----------------------------------------------------------------------

function SearchBar()
{

   global $SETArchiveYearStart, $SETArchiveYearEnd;

   print("<table class=\"searchtable\" cellpadding=\"0\" cellspacing=\"0\">");
   print("<form action=\"". $_SERVER['PHP_SELF'] . "\" method=\"post\">");
   print("  <tr>\n");
   print("    <td>\n");
   
   print("<div id=\"searchtitle\">Search telephone directory</div>\n");
   
   print("<div id=\"searchfields\">\n");
   print("<table>\n");
   print("  <tr>\n");
   print("    <td class=\"searchfieldshead\">Keyword</td>\n");
   print("    <td class=\"searchfieldshead\">Department</td>\n");
   print("    <td></td>\n");
   print("  </tr>\n");
   print("  <tr>\n");
   print("    <td><input type=\"text\" name=\"key\"></td>\n");
   print("    <td>\n");
   include("includes/departmentdropdownsearch.php");
   print("    </td>\n");
   print("    <td><input type=\"submit\" value=\"go\"></td>\n");
   print("  </tr>\n");
  
   print("</table>\n");
   print("</div>\n"); //end searchfields div
   
   print("</td>\n");
   print("  </tr>\n");
   print("</table>\n");
   print("</form>\n");
}




function ViewContact($intContactID) {

   //build SQL statement
   $SQLstmt = "SELECT contacttitle, firstname, lastname, qualifications, contactposition, company, departmentID, buildingroom, phonenumber1, internalphonenumber, phonenumber2, mobilecell, fax, email, chat, website, address, city, suburb, tdstate, zippostcode, country, description FROM tdcontact WHERE contactID = '$intContactID'";
   
   $resultSet = dbaction($SQLstmt);
   $row = getrsrow($resultSet);
   
   print("<div id=\"viewresult\">\n");
   
   print("<div id=\"backcontainer\">\n");
   backlink();
   print("</div>\n"); // end backcontainer div
      
   print("<div id=\"viewname\">");
   print $row["contacttitle"];
   if ($row["contacttitle"] != "")
      print("&nbsp;");
   print $row["firstname"] . " " . $row["lastname"];
   print("</div>\n");
   print("<div id=\"viewqualifications\">" . $row["qualifications"] . "</div>\n");
   print("<div id=\"viewspacing1\"></div>\n");
   if ($row["contactposition"] != "")
   {
      print("<div id=\"viewposition\">" . $row["contactposition"] . "</div>\n");
   }
   if ($row["company"] != "")
   {
      print("<div id=\"viewcompany\">" . $row["company"] . "</div>\n");
   }
   if ($row["departmentID"] != "" && $row["departmentID"] != 0)
   {
      $SQLstmt2 = "SELECT departmentname FROM tddepartment WHERE departmentID = '" . $row["departmentID"] . "'";
      $resultSet2 = dbaction($SQLstmt2);
      $row2 = getrsrow($resultSet2);	  
      print("<div id=\"viewdepartment\">" . $row2["departmentname"] . "</div>\n");
   }	  
   print("<div id=\"viewbuildingroom\">" . $row["buildingroom"] . "</div>\n");
   print("<div id=\"viewspacing2\"></div>\n");
   print("<table>\n");
   print("  <tr>\n");
   print("    <td class=\"viewcontacttblhead\">Telephone:</td>\n");
   print("    <td class=\"viewcontacttbltext\">" . $row["phonenumber1"] . "</td>\n");
   print("  </tr>\n");
   print("  <tr>\n");
   print("    <td class=\"viewcontacttblhead\">Ext:</td>\n");
   print("    <td class=\"viewcontacttbltext\">" . $row["internalphonenumber"] . "</td>\n");
   print("  </tr>\n");
   print("  <tr>\n");
   print("    <td class=\"viewcontacttblhead\">Telephone 2:</td>\n");
   print("    <td class=\"viewcontacttbltext\">" . $row["phonenumber2"] . "</td>\n");
   print("  </tr>\n");
   print("  <tr>\n");
   print("    <td class=\"viewcontacttblhead\">Mobile:</td>\n");
   print("    <td class=\"viewcontacttbltext\">" . $row["mobilecell"] . "</td>\n");
   print("  </tr>\n");
   print("  <tr>\n");
   print("    <td class=\"viewcontacttblhead\">Fax:</td>\n");
   print("    <td class=\"viewcontacttbltext\">" . $row["fax"] . "</td>\n");
   print("  </tr>\n");
   print("  <tr>\n");
   print("    <td class=\"viewcontacttblhead\">Email:</td>\n");
   print("    <td class=\"viewcontacttbltext\"><a href=\"mailto:" . $row["email"] . "\">" . $row["email"] . "</a></td>\n");
   print("  </tr>\n");
   print("  <tr>\n");
   print("    <td class=\"viewcontacttblhead\">Chat:</td>\n");
   print("    <td class=\"viewcontacttbltext\">" . $row["chat"] . "</td>\n");
   print("  </tr>\n");   
   print("  <tr>\n");
   print("    <td class=\"viewcontacttblhead\">Web:</td>\n");
   print("    <td class=\"viewcontacttbltext\"><a href=\"http://" . $row["website"] . "\" target=\"_blank\">" . $row["website"] . "</a></td>\n");
   print("  </tr>\n");  
   print("</table>\n");   
   print("<div id=\"viewspacing3\"></div>\n");
   print("<div id=\"viewaddress\">");
   if ($row["address"] != "")
   {
      print("" . $row["address"] . "&nbsp;&nbsp;");
   }
   if ($row["suburb"] != "")
   {
      print("" . $row["suburb"] . "&nbsp;&nbsp;");
   }
   if ($row["city"] != "")
   {
      print("" . $row["city"] . "&nbsp;&nbsp;");
   }
   if ($row["tdstate"] != "")
   {
      print("" . $row["tdstate"] . "&nbsp;&nbsp;");
   }
   if ($row["zippostcode"] != "")
   {
      print("" . $row["zippostcode"] . "&nbsp;&nbsp;");
   }
   if ($row["country"] != "")
   {
      print($row["country"]);
   }   
   print("</div>\n");  // end viewaddress div  
   print("<div id=\"viewspacing4\"></div>\n");
   if ($row["description"] != "") 
   {
      print("<div id=\"viewdescription\">" . $row["description"] . "</div>\n");
   }
   print("</div>\n"); // end viewresult
   
}




function backlink() {

   global $strPublicState;

   print("<div id=\"backlink\"><a href=\"index.php?search=true$strPublicState\">Back to Telephone Directory</a></div>\n");

}




function TelephoneDirectory() {

   global $SQLstmt, $SETDebug, $strPublicState;

   if ($SETDebug == "ON")
   {
      print $SQLstmt;
   }
   
   $resultSet = dbaction($SQLstmt);
   
   print("<div id=\"resultlist\">\n");
   while ($row = getrsrow($resultSet))
   {  
      print("<div class=\"resultbox\">\n");
      print("<div class=\"resultname\">" . $row["firstname"] . " " . $row["lastname"] . "</div>\n");
	  if ($row["contactposition"] != "")
	  {
	     print("<div class=\"resultposition\">" . $row["contactposition"] . "</div>\n");
	  }
	  if ($row["buildingroom"] != "")
	  {
	     print("<div class=\"resultbuildingroom\">" . $row["buildingroom"] . "</div>\n");
	  }
	  
	  print("<div class=\"resultphone\">");
	  if ($row["phonenumber1"] != "")
	  {
	     print("ph: " . $row["phonenumber1"] . "&nbsp;&nbsp;&nbsp;");
	  }
	  if ($row["internalphonenumber"] != "")
      {	  
		 print("ext: " . $row["internalphonenumber"] . "&nbsp;&nbsp;&nbsp;");
	  }
	  if ($row["phonenumber2"] != "")
      {	  
		 print("other: " . $row["phonenumber2"] . "&nbsp;&nbsp;&nbsp;");
	  }
	  if ($row["mobilecell"] != "")
      {	  
		 print("mobile: " . $row["mobilecell"]);
	  }
	  print("</div>\n"); //end resultphone div
	  if ($row["fax"] != "")
	  {
	     print("<div class=\"resultfax\">fax: " . $row["fax"] . "</div>\n");
	  }
	  if ($row["email"] != "")
	  {
	     print("<div class=\"resultemail\">email: <a href=\"mailto:" . $row["email"] . "\">" . $row["email"] . "</a></div>\n");
	  }
	  print("<div class=\"moreinfo\"><a href=\"index.php?stype=view&id=" . $row["contactID"] . "$strPublicState\">More Info</a></div>\n");
	  print("</div>\n"); // end resultbox div
      print("<div class=\"resultsep\"></div>\n");
   }
   print("</div>\n"); //end resultlist div
   
}




// ----------------------------------------------------------------------
//   Function    : SqlPrep
//   Description : sets SQL variables to find number of records found
//                 and prepare to run main query
//   Usage       : SqlPrep()
//
// ----------------------------------------------------------------------

function SqlPrep() {

   global $SQLstmt, $SQLselect, $SQLfrom, $SQLwhere;
   global $strKey, $intDepartment;
   global $SETDebug;


   //Build FROM part
   $SQLfrom =  " FROM tdcontact";

   //Build WHERE part
   $SQLwhere = " WHERE (recordstatus = 'active')";
   

   if ($strKey != "")
   {
      $SQLwhere .= " AND (firstname LIKE '%$strKey%' OR lastname LIKE '%$strKey%'" .
				   " OR contactposition LIKE '%$strKey%')";
   }

   if ($intDepartment != "")
   {
      $SQLwhere .= " AND departmentID = '$intDepartment'";
   }
   
   //SQL to find number of records
   $SQLselect = "SELECT COUNT(*)";
   $SQLstmt = $SQLselect . $SQLfrom . $SQLwhere;


   if ($SETDebug == "ON")
   {
      print("<div class=\"debug\">$SQLstmt</div>");
   }

}




// ----------------------------------------------------------------------
//   Function    : SqlForResults
//   Description : creates the remainder of the sql parts required and 
//                 sets the actual record retrieval SQL query 
//   Usage       : SqlForResults()
//
// ----------------------------------------------------------------------

function SqlForResults() {

   global $SQLstmt, $SQLselect, $SQLfrom, $SQLwhere, $SQLorder;
   global $intStartRecord;
   global $intPublicPageSize;
   global $SETDebug;

   //SQL to retrieve all or a subset of records
   $SQLselect = "SELECT contactID, lastname, firstname, contactposition, buildingroom, phonenumber1, internalphonenumber, phonenumber2, mobilecell, fax, email";
   $SQLorder = " ORDER BY lastname ASC";
   $SQLlimit = " LIMIT $intStartRecord, $intPublicPageSize";
   $SQLstmt = $SQLselect . $SQLfrom . $SQLwhere . $SQLorder . $SQLlimit;

   if ($SETDebug == "ON")
   {
      print("<div class=\"debug\">$SQLstmt</div>\n");
   }

}




// ----------------------------------------------------------------------
//   Function    : SearchFeedback
//   Description : prints feedback on search parameters
//   Usage       : SearchFeedback()
//
// ----------------------------------------------------------------------

function SearchFeedback() {

   global $strKey, $dtMonth, $dtYear, $intDepartment;

   print("<div id=\"searchfeedback\">\n");

   if ($strKey != "" || $intDepartment != "")
   {

      print("You searched on&nbsp;&nbsp;");
  
      if ($strKey != "")
	  {
         print("Keyword: <span class=\"searchfeedbackbold\">" . stripslashes($strKey) . "</span> &nbsp;&nbsp;");   		 
      } 	 
   
      if ($intDepartment != "")
	  {
	     $SQLstmt2 = "SELECT departmentname FROM tddepartment WHERE departmentID = '$intDepartment'";
		 $resultSet2 = dbaction($SQLstmt2);
		 $row2 = getrsrow($resultSet2);
		 print("Department: <span class=\"searchfeedbackbold\">" . $row2["departmentname"] . "</span>");
		 
	  }
   
   }

   print("</div>\n"); // end searchfeedback div

}




// ----------------------------------------------------------------------
//   Function    : ResultsStatus
//   Description : shows status info on the number of records returned in
//                 a result list and which ones are currently shown
//   Usage       : ResultsStatus()
//
// ----------------------------------------------------------------------

function ResultsStatus() {

   global $intRecordsFound;
   global $intPage;
   global $intStartRecord;
   global $intPublicPageSize;

   print("<div id=\"recordsfound\">");
   print("Showing results <span class=\"recordsfoundbold\">" . ($intStartRecord+1) . ""); 
   print("</span> - <span class=\"recordsfoundbold\">");

   if (($intPublicPageSize*$intPage) < $intRecordsFound)
      print($intPublicPageSize*$intPage);
   else
      print($intRecordsFound);            

   print(" </span> of <span class=\"recordsfoundbold\">$intRecordsFound</span>");
   print("</div>\n");

}




// ----------------------------------------------------------------------
//   Function    : NoRecordsFound
//   Description : print no records found message
//   Usage       : NoRecordsFound()
//
// ----------------------------------------------------------------------

function NoRecordsFound() {

   print("<div id=\"norecordsfound\">");
   print("Sorry! Your search ");
   print("returned no results at this time.");
   print("</div>\n");

}




// ----------------------------------------------------------------------
//   Function    : RecordCount
//   Description : returns number of records found during search
//   Usage       : RecordCount($SQLstmt)
//   Parameters  : $SQLstmt - SQL for total query record count
//   Returns     : $intRecordsFound - how many records will be returned
//                 by query
//
// ----------------------------------------------------------------------

function RecordCount($SQLstmt) {

   $resultSet = dbaction($SQLstmt);
   $row = getrsrow($resultSet);
   $intRecordsFound = $row[0];
   return $intRecordsFound;

}




// ----------------------------------------------------------------------
//   Function    : GetPageTotal
//   Description : return the number of record result pages available
//                 using the total number of records found and the
//                 page size from the settings.php file
//   Usage       : GetPageTotal()
//   Returns     : intTotalPages - how many record result pages there are
//                 given the number of records found and the page size
//                 setting
//
// ----------------------------------------------------------------------

function GetPageTotal() {

   global $intRecordsFound;
   global $intPublicPageSize;

   if (fmod($intRecordsFound, $intPublicPageSize) == 0)
   {
      $intTotalPages = $intRecordsFound/$intPublicPageSize;      
   }
   else
   {
      $intTotalPages = ceil($intRecordsFound/$intPublicPageSize);
   }

   return $intTotalPages;

}




// ----------------------------------------------------------------------
//   Function    : DisplayPagedNavigation
//   Description : diplays the page navigation links when a search 
//                 result has more than 1 page of records
//   Usage       : DisplayPagedNavigation()
//
// ----------------------------------------------------------------------

function DisplayPagedNavigation() {

   global $intTotalPages;
   global $intPage;
   global $intPublicChapterSize;

   global $strNavPublicState;

   // only show page navigation links if number of pages > 1
   if ($intTotalPages > 1)
   {


      // calculate current chapter based on current page
      if (fmod($intPage, $intPublicChapterSize) == 0)
         $intChapter = ($intPage/$intPublicChapterSize);
      else
         $intChapter = ceil($intPage/$intPublicChapterSize); 


      // display paged record navigation bar
      print("<div id=\"pagenavcontainer\">\n"); 
      print("<div id=\"pagenavigation\">\n");


      // display previous chapter link if it exists
      if ($intChapter > 1)
      {
         print("<div id=\"pagenavprev\">"); 
         print("<a href=\"" . $_SERVER['PHP_SELF'] . "?search=true$strNavPublicState");
         print("&pn=" . ((($intChapter-1)*$intPublicChapterSize)-$intPublicChapterSize+1) . "");
         print("\">Prev $intPublicChapterSize pages</a>");
         print("</div>\n");
      }


      // display page links
      $intStartAt = (($intChapter*$intPublicChapterSize) - ($intPublicChapterSize - 1));

      if ($intTotalPages < ($intChapter*$intPublicChapterSize))
         $intFinishAt = $intTotalPages;
      else
         $intFinishAt = ($intChapter*$intPublicChapterSize);

      for($x=$intStartAt;$x<=$intFinishAt;$x++)
      {
         if ($intPage == $x)
         {
            print("<div class=\"pagenavbox\">$x</div>\n");
         }
         else 
         {
            print("<div class=\"pagenavbox\">");
            print("<a href=\"" . $_SERVER['PHP_SELF'] . "?search=true$strNavPublicState&pn=$x");
            print("\">$x</a></div>\n");
         }
      }

        
      // display next chapter link if it exists
      if (($intChapter * $intPublicChapterSize) < $intTotalPages)
      {
         print("<div id=\"pagenavnext\">");
         print("<a href=\"" . $_SERVER['PHP_SELF'] . "?search=true$strNavPublicState");
         print("&pn=" . (($intChapter*$intPublicChapterSize)+1) . "");
         print("\">Next $intPublicChapterSize pages</a>");
         print("</div>\n");
      }


      print("</div>\n"); // end pagenavigation div
      print("</div>\n"); // end pagenavcontainer div

   } // end if total pages > 0


}




// ----------------------------------------------------------------------
//   Function    : GetPublicState
//   Description : return part of a querystring which can be added to
//                 links to maintain search state
//   Usage       : GetPublicState($intMode)
//   Arguments   : $intMode -  identifies whether to return querystring
//                             components for general or page navigation
//                             links
//
// ----------------------------------------------------------------------

function GetPublicState($intMode) {


   $strPublicState = "";
   $strNavPublicState = "";

   
   if (isset($_REQUEST['key']))
   {
      if ($_REQUEST['key'] != "")
      { 
         $strPublicState .= "&key=" . urlencode($_REQUEST['key']);
      }
   }
   
   if (isset($_REQUEST['department']))
   {
      if ($_REQUEST['department'] != "")
      { 
         $strPublicState .= "&department=" . urlencode($_REQUEST['department']);
      }
   }

   
   $strNavPublicState = $strPublicState;


   if (isset($_REQUEST['pn']))
   {
      $strPublicState .= "&pn=" . $_REQUEST['pn'];
   }


   //return result based on $intMode supplied
   if ($intMode == 0)
   {
      //pass back querystring version of current state
      return $strPublicState;
   }
   else if ($intMode == 1)
   {
      //pass back querystring version of current state for navigation links
      return $strNavPublicState;  
   }

}




?>
